# cs_vmsnapshot – Manages VM snapshots on Apache CloudStack based clouds

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Create, remove and revert VM from snapshots.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6

- cs >= 0.6.10

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
account string |  | Account the VM snapshot is related to.

api_http_method
string

Choices:
- get
- post

HTTP method used to query the API endpoint.
If not given, the `CLOUDSTACK_METHOD` env variable is considered.
As the last option, the value is taken from the ini config file, also see the notes.
Fallback value is `get` if not specified.

api_key string |  | API key of the CloudStack API. If not given, the `CLOUDSTACK_KEY` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_region string | Default: "cloudstack" | Name of the ini section in the `cloustack.ini` file. If not given, the `CLOUDSTACK_REGION` env variable is considered.
api_secret string |  | Secret key of the CloudStack API. If not set, the `CLOUDSTACK_SECRET` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_timeout integer |  | HTTP timeout in seconds. If not given, the `CLOUDSTACK_TIMEOUT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is 10 seconds if not specified.
api_url string |  | URL of the CloudStack API e.g. https://cloud.example.com/client/api. If not given, the `CLOUDSTACK_ENDPOINT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
description string |  | Description of the snapshot.
domain string |  | Domain the VM snapshot is related to.
name string / required |  | Unique Name of the snapshot. In CloudStack terms display name. aliases: display_name

poll_async
boolean

Choices:
- no
- yes ←

Poll async jobs until job has finished.

project string |  | Name of the project the VM is assigned to.

snapshot_memory
boolean

Choices:
- no ←
- yes

Snapshot memory if set to true.

state
string

Choices:
- present ←
- absent
- revert

State of the snapshot.

tags list added in 2.4 |  | List of tags. Tags are a list of dictionaries having keys key and value. To delete all tags, set a empty list e.g. tags: []. aliases: tag
vm string / required |  | Name of the virtual machine.
zone string |  | Name of the zone in which the VM is in. If not set, default zone is used.

## Notes

Note

- Ansible uses the `cs` library’s configuration method if credentials are not provided by the arguments `api_url`, `api_key`, `api_secret`. Configuration is read from several locations, in the following order. The `CLOUDSTACK_ENDPOINT`, `CLOUDSTACK_KEY`, `CLOUDSTACK_SECRET` and `CLOUDSTACK_METHOD`. `CLOUDSTACK_TIMEOUT` environment variables. A `CLOUDSTACK_CONFIG` environment variable pointing to an `.ini` file. A `cloudstack.ini` file in the current working directory. A `.cloudstack.ini` file in the users home directory. Optionally multiple credentials and endpoints can be specified using ini sections in `cloudstack.ini`. Use the argument `api_region` to select the section name, default section is `cloudstack`. See https://github.com/exoscale/cs for more information.

- A detailed guide about cloudstack modules can be found in the CloudStack Cloud Guide.

- This module supports check mode.

## Examples

    - name: Create a VM snapshot of disk and memory before an upgrade
      cs_vmsnapshot:
        name: Snapshot before upgrade
        vm: web-01
        snapshot_memory: yes
      delegate_to: localhost

    - name: Revert a VM to a snapshot after a failed upgrade
      cs_vmsnapshot:
        name: Snapshot before upgrade
        vm: web-01
        state: revert
      delegate_to: localhost

    - name: Remove a VM snapshot after successful upgrade
      cs_vmsnapshot:
        name: Snapshot before upgrade
        vm: web-01
        state: absent
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
account string | success | Account the vm snapshot is related to. Sample: example account
created string | success | date of the snapshot. Sample: 2015-03-29T14:57:06+0200
current boolean | success | true if the snapshot is current Sample: True
description string | success | description of vm snapshot Sample: snapshot brought to you by Ansible
display_name string | success | Display name of the snapshot. Sample: snapshot before update
domain string | success | Domain the vm snapshot is related to. Sample: example domain
id string | success | UUID of the snapshot. Sample: a6f7a5fc-43f8-11e5-a151-feff819cdc9f
name string | success | Name of the snapshot. Sample: snapshot before update
project string | success | Name of project the vm snapshot is related to. Sample: Production
state string | success | state of the vm snapshot Sample: Allocated
type string | success | type of vm snapshot Sample: DiskAndMemory

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]

- This module is maintained by the Ansible Community. [community]

### Authors

- René Moser (@resmo)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.